# Copyright (C) 2008-2014 LAAS-CNRS, JRL AIST-CNRS.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

#.rst:
#  By default, Doxygen_, if found, is used to generate a HTML documentation
#  of the code. You can configure it as follows:
#
#  - Many Doxygen options can be configured from CMake itself. E.g. Doxygen option
#    `PROJECT_NAME` can be set using CMake variable `DOXYGEN_PROJECT_NAME`.
#
#  - If present, the file *doc/Doxyfile.extra.in* will be configured and append to
#    the above mentionned configuration file.
#
#  For a good documentation of the available options, see either `local documentation
#  <file:///usr/share/doc/doxygen/html/config.html>`_ provided by package *doxygen-doc*
#  or the `online version <http://www.doxygen.nl/manual/config.html>`_.
#
#  .. _Doxygen: http://www.doxygen.nl

# _SETUP_DOXYGEN_DEFAULT_OPTIONS
# ----------------------------
#
# Set default options for doxygen configuration when the user didn't specify
# those options already.
MACRO(_SETUP_DOXYGEN_DEFAULT_OPTIONS)
  IF(NOT DEFINED DOXYGEN_DOXYFILE_ENCODING)
    SET(DOXYGEN_DOXYFILE_ENCODING UTF-8)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_PROJECT_NAME)
    SET(DOXYGEN_PROJECT_NAME "My Project")
  ENDIF()
  IF(NOT DEFINED DOXYGEN_OUTPUT_DIRECTORY)
    SET(DOXYGEN_OUTPUT_DIRECTORY .)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_CREATE_SUBDIRS)
    SET(DOXYGEN_CREATE_SUBDIRS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_ALLOW_UNICODE_NAMES)
    SET(DOXYGEN_ALLOW_UNICODE_NAMES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_OUTPUT_LANGUAGE)
    SET(DOXYGEN_OUTPUT_LANGUAGE English)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_OUTPUT_TEXT_DIRECTION)
    SET(DOXYGEN_OUTPUT_TEXT_DIRECTION None)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_BRIEF_MEMBER_DESC)
    SET(DOXYGEN_BRIEF_MEMBER_DESC YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_REPEAT_BRIEF)
    SET(DOXYGEN_REPEAT_BRIEF YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_ABBREVIATE_BRIEF)
    SET(DOXYGEN_ABBREVIATE_BRIEF "The $name class" 
                                 "The $name widget" 
                                 "The $name file" 
                                 is 
                                 provides 
                                 specifies 
                                 contains 
                                 represents 
                                 a 
                                 an 
                                 the)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_ALWAYS_DETAILED_SEC)
    SET(DOXYGEN_ALWAYS_DETAILED_SEC NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INLINE_INHERITED_MEMB)
    SET(DOXYGEN_INLINE_INHERITED_MEMB NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_FULL_PATH_NAMES)
    SET(DOXYGEN_FULL_PATH_NAMES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SHORT_NAMES)
    SET(DOXYGEN_SHORT_NAMES YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_JAVADOC_AUTOBRIEF)
    SET(DOXYGEN_JAVADOC_AUTOBRIEF YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_JAVADOC_BANNER)
    SET(DOXYGEN_JAVADOC_BANNER YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_QT_AUTOBRIEF)
    SET(DOXYGEN_QT_AUTOBRIEF NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MULTILINE_CPP_IS_BRIEF)
    SET(DOXYGEN_MULTILINE_CPP_IS_BRIEF NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INHERIT_DOCS)
    SET(DOXYGEN_INHERIT_DOCS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SEPARATE_MEMBER_PAGES)
    SET(DOXYGEN_SEPARATE_MEMBER_PAGES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_TAB_SIZE)
    SET(DOXYGEN_TAB_SIZE 2)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_OPTIMIZE_OUTPUT_FOR_C)
    SET(DOXYGEN_OPTIMIZE_OUTPUT_FOR_C NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_OPTIMIZE_OUTPUT_JAVA)
    SET(DOXYGEN_OPTIMIZE_OUTPUT_JAVA NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_OPTIMIZE_FOR_FORTRAN)
    SET(DOXYGEN_OPTIMIZE_FOR_FORTRAN NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_OPTIMIZE_OUTPUT_VHDL)
    SET(DOXYGEN_OPTIMIZE_OUTPUT_VHDL NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_OPTIMIZE_OUTPUT_SLICE)
    SET(DOXYGEN_OPTIMIZE_OUTPUT_SLICE NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MARKDOWN_SUPPORT)
    SET(DOXYGEN_MARKDOWN_SUPPORT NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_TOC_INCLUDE_HEADINGS)
    SET(DOXYGEN_TOC_INCLUDE_HEADINGS 0)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_AUTOLINK_SUPPORT)
    SET(DOXYGEN_AUTOLINK_SUPPORT YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_BUILTIN_STL_SUPPORT)
    SET(DOXYGEN_BUILTIN_STL_SUPPORT YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_CPP_CLI_SUPPORT)
    SET(DOXYGEN_CPP_CLI_SUPPORT NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SIP_SUPPORT)
    SET(DOXYGEN_SIP_SUPPORT NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_IDL_PROPERTY_SUPPORT)
    SET(DOXYGEN_IDL_PROPERTY_SUPPORT YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DISTRIBUTE_GROUP_DOC)
    SET(DOXYGEN_DISTRIBUTE_GROUP_DOC NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GROUP_NESTED_COMPOUNDS)
    SET(DOXYGEN_GROUP_NESTED_COMPOUNDS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SUBGROUPING)
    SET(DOXYGEN_SUBGROUPING YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INLINE_GROUPED_CLASSES)
    SET(DOXYGEN_INLINE_GROUPED_CLASSES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INLINE_SIMPLE_STRUCTS)
    SET(DOXYGEN_INLINE_SIMPLE_STRUCTS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_TYPEDEF_HIDES_STRUCT)
    SET(DOXYGEN_TYPEDEF_HIDES_STRUCT NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_LOOKUP_CACHE_SIZE)
    SET(DOXYGEN_LOOKUP_CACHE_SIZE 0)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTRACT_ALL)
    SET(DOXYGEN_EXTRACT_ALL YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTRACT_PRIVATE)
    SET(DOXYGEN_EXTRACT_PRIVATE NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTRACT_PRIV_VIRTUAL)
    SET(DOXYGEN_EXTRACT_PRIV_VIRTUAL NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTRACT_PACKAGE)
    SET(DOXYGEN_EXTRACT_PACKAGE NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTRACT_STATIC)
    SET(DOXYGEN_EXTRACT_STATIC YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTRACT_LOCAL_CLASSES)
    SET(DOXYGEN_EXTRACT_LOCAL_CLASSES YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTRACT_LOCAL_METHODS)
    SET(DOXYGEN_EXTRACT_LOCAL_METHODS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTRACT_ANON_NSPACES)
    SET(DOXYGEN_EXTRACT_ANON_NSPACES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HIDE_UNDOC_MEMBERS)
    SET(DOXYGEN_HIDE_UNDOC_MEMBERS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HIDE_UNDOC_CLASSES)
    SET(DOXYGEN_HIDE_UNDOC_CLASSES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HIDE_FRIEND_COMPOUNDS)
    SET(DOXYGEN_HIDE_FRIEND_COMPOUNDS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HIDE_IN_BODY_DOCS)
    SET(DOXYGEN_HIDE_IN_BODY_DOCS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INTERNAL_DOCS)
    SET(DOXYGEN_INTERNAL_DOCS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_CASE_SENSE_NAMES)
    SET(DOXYGEN_CASE_SENSE_NAMES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HIDE_SCOPE_NAMES)
    SET(DOXYGEN_HIDE_SCOPE_NAMES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HIDE_COMPOUND_REFERENCE)
    SET(DOXYGEN_HIDE_COMPOUND_REFERENCE NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SHOW_INCLUDE_FILES)
    SET(DOXYGEN_SHOW_INCLUDE_FILES YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SHOW_GROUPED_MEMB_INC)
    SET(DOXYGEN_SHOW_GROUPED_MEMB_INC NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_FORCE_LOCAL_INCLUDES)
    SET(DOXYGEN_FORCE_LOCAL_INCLUDES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INLINE_INFO)
    SET(DOXYGEN_INLINE_INFO YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SORT_MEMBER_DOCS)
    SET(DOXYGEN_SORT_MEMBER_DOCS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SORT_BRIEF_DOCS)
    SET(DOXYGEN_SORT_BRIEF_DOCS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SORT_MEMBERS_CTORS_1ST)
    SET(DOXYGEN_SORT_MEMBERS_CTORS_1ST NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SORT_GROUP_NAMES)
    SET(DOXYGEN_SORT_GROUP_NAMES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SORT_BY_SCOPE_NAME)
    SET(DOXYGEN_SORT_BY_SCOPE_NAME NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_STRICT_PROTO_MATCHING)
    SET(DOXYGEN_STRICT_PROTO_MATCHING NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_TODOLIST)
    SET(DOXYGEN_GENERATE_TODOLIST YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_TESTLIST)
    SET(DOXYGEN_GENERATE_TESTLIST YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_BUGLIST)
    SET(DOXYGEN_GENERATE_BUGLIST YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_DEPRECATEDLIST)
    SET(DOXYGEN_GENERATE_DEPRECATEDLIST YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MAX_INITIALIZER_LINES)
    SET(DOXYGEN_MAX_INITIALIZER_LINES 30)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SHOW_USED_FILES)
    SET(DOXYGEN_SHOW_USED_FILES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SHOW_FILES)
    SET(DOXYGEN_SHOW_FILES YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SHOW_NAMESPACES)
    SET(DOXYGEN_SHOW_NAMESPACES YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_QUIET)
    SET(DOXYGEN_QUIET YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_WARNINGS)
    SET(DOXYGEN_WARNINGS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_WARN_IF_UNDOCUMENTED)
    SET(DOXYGEN_WARN_IF_UNDOCUMENTED YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_WARN_IF_DOC_ERROR)
    SET(DOXYGEN_WARN_IF_DOC_ERROR YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_WARN_NO_PARAMDOC)
    SET(DOXYGEN_WARN_NO_PARAMDOC YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_WARN_AS_ERROR)
    SET(DOXYGEN_WARN_AS_ERROR NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_WARN_FORMAT)
    SET(DOXYGEN_WARN_FORMAT "$file:$line: $text")
  ENDIF()
  IF(NOT DEFINED DOXYGEN_WARN_LOGFILE)
    SET(DOXYGEN_WARN_LOGFILE doxygen.log)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INPUT_ENCODING)
    SET(DOXYGEN_INPUT_ENCODING UTF-8)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_FILE_PATTERNS)
    SET(DOXYGEN_FILE_PATTERNS *.cc
                              *.cpp 
                              *.hh 
                              *.hxx)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_RECURSIVE)
    SET(DOXYGEN_RECURSIVE YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXCLUDE_SYMLINKS)
    SET(DOXYGEN_EXCLUDE_SYMLINKS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXAMPLE_PATTERNS)
    SET(DOXYGEN_EXAMPLE_PATTERNS *)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXAMPLE_RECURSIVE)
    SET(DOXYGEN_EXAMPLE_RECURSIVE NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_FILTER_SOURCE_FILES)
    SET(DOXYGEN_FILTER_SOURCE_FILES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SOURCE_BROWSER)
    SET(DOXYGEN_SOURCE_BROWSER NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INLINE_SOURCES)
    SET(DOXYGEN_INLINE_SOURCES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_STRIP_CODE_COMMENTS)
    SET(DOXYGEN_STRIP_CODE_COMMENTS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_REFERENCED_BY_RELATION)
    SET(DOXYGEN_REFERENCED_BY_RELATION YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_REFERENCES_RELATION)
    SET(DOXYGEN_REFERENCES_RELATION YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_REFERENCES_LINK_SOURCE)
    SET(DOXYGEN_REFERENCES_LINK_SOURCE YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SOURCE_TOOLTIPS)
    SET(DOXYGEN_SOURCE_TOOLTIPS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_USE_HTAGS)
    SET(DOXYGEN_USE_HTAGS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_VERBATIM_HEADERS)
    SET(DOXYGEN_VERBATIM_HEADERS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_CLANG_ASSISTED_PARSING)
    SET(DOXYGEN_CLANG_ASSISTED_PARSING NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_ALPHABETICAL_INDEX)
    SET(DOXYGEN_ALPHABETICAL_INDEX YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_COLS_IN_ALPHA_INDEX)
    SET(DOXYGEN_COLS_IN_ALPHA_INDEX 5)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_HTML)
    SET(DOXYGEN_GENERATE_HTML YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HTML_OUTPUT)
    SET(DOXYGEN_HTML_OUTPUT doxygen-html)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HTML_FILE_EXTENSION)
    SET(DOXYGEN_HTML_FILE_EXTENSION .html)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HTML_COLORSTYLE_HUE)
    SET(DOXYGEN_HTML_COLORSTYLE_HUE 220)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HTML_COLORSTYLE_SAT)
    SET(DOXYGEN_HTML_COLORSTYLE_SAT 100)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HTML_COLORSTYLE_GAMMA)
    SET(DOXYGEN_HTML_COLORSTYLE_GAMMA 80)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HTML_TIMESTAMP)
    SET(DOXYGEN_HTML_TIMESTAMP YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HTML_DYNAMIC_MENUS)
    SET(DOXYGEN_HTML_DYNAMIC_MENUS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HTML_DYNAMIC_SECTIONS)
    SET(DOXYGEN_HTML_DYNAMIC_SECTIONS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HTML_INDEX_NUM_ENTRIES)
    SET(DOXYGEN_HTML_INDEX_NUM_ENTRIES 100)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_DOCSET)
    SET(DOXYGEN_GENERATE_DOCSET NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOCSET_FEEDNAME)
    SET(DOXYGEN_DOCSET_FEEDNAME "Doxygen generated docs")
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOCSET_BUNDLE_ID)
    SET(DOXYGEN_DOCSET_BUNDLE_ID "org.doxygen.${PACKAGE_NAME}")
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOCSET_PUBLISHER_ID)
    SET(DOXYGEN_DOCSET_PUBLISHER_ID org.doxygen.Publisher)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOCSET_PUBLISHER_NAME)
    SET(DOXYGEN_DOCSET_PUBLISHER_NAME Publisher)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_HTMLHELP)
    SET(DOXYGEN_GENERATE_HTMLHELP NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_CHI)
    SET(DOXYGEN_GENERATE_CHI NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_BINARY_TOC)
    SET(DOXYGEN_BINARY_TOC NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_TOC_EXPAND)
    SET(DOXYGEN_TOC_EXPAND NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_QHP)
    SET(DOXYGEN_GENERATE_QHP NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_QHP_NAMESPACE)
    SET(DOXYGEN_QHP_NAMESPACE "org.doxygen.${PACKAGE_NAME}")
  ENDIF()
  IF(NOT DEFINED DOXYGEN_QHP_VIRTUAL_FOLDER)
    SET(DOXYGEN_QHP_VIRTUAL_FOLDER doc)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_ECLIPSEHELP)
    SET(DOXYGEN_GENERATE_ECLIPSEHELP NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_ECLIPSE_DOC_ID)
    SET(DOXYGEN_ECLIPSE_DOC_ID "org.doxygen.${PACKAGE_NAME}")
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DISABLE_INDEX)
    SET(DOXYGEN_DISABLE_INDEX NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_ENUM_VALUES_PER_LINE)
    SET(DOXYGEN_ENUM_VALUES_PER_LINE 1)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_TREEVIEW)
    SET(DOXYGEN_GENERATE_TREEVIEW YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_TREEVIEW_WIDTH)
    SET(DOXYGEN_TREEVIEW_WIDTH 250)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXT_LINKS_IN_WINDOW)
    SET(DOXYGEN_EXT_LINKS_IN_WINDOW NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_FORMULA_FONTSIZE)
    SET(DOXYGEN_FORMULA_FONTSIZE 10)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_FORMULA_TRANSPARENT)
    SET(DOXYGEN_FORMULA_TRANSPARENT YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_USE_MATHJAX)
    SET(DOXYGEN_USE_MATHJAX NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MATHJAX_FORMAT)
    SET(DOXYGEN_MATHJAX_FORMAT SVG)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MATHJAX_RELPATH)
    SET(DOXYGEN_MATHJAX_RELPATH https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SEARCHENGINE)
    SET(DOXYGEN_SEARCHENGINE YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SERVER_BASED_SEARCH)
    SET(DOXYGEN_SERVER_BASED_SEARCH NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTERNAL_SEARCH)
    SET(DOXYGEN_EXTERNAL_SEARCH NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SEARCHDATA_FILE)
    SET(DOXYGEN_SEARCHDATA_FILE searchdata.xml)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_LATEX)
    SET(DOXYGEN_GENERATE_LATEX NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_LATEX_OUTPUT)
    SET(DOXYGEN_LATEX_OUTPUT doxygen-latex)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_LATEX_CMD_NAME)
    SET(DOXYGEN_LATEX_CMD_NAME latex)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MAKEINDEX_CMD_NAME)
    SET(DOXYGEN_MAKEINDEX_CMD_NAME makeindex)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_LATEX_MAKEINDEX_CMD)
    SET(DOXYGEN_LATEX_MAKEINDEX_CMD makeindex)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_COMPACT_LATEX)
    SET(DOXYGEN_COMPACT_LATEX YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_PAPER_TYPE)
    SET(DOXYGEN_PAPER_TYPE a4wide)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTRA_PACKAGES)
    SET(DOXYGEN_EXTRA_PACKAGES "amssymb,amsmath")
  ENDIF()
  IF(NOT DEFINED DOXYGEN_PDF_HYPERLINKS)
    SET(DOXYGEN_PDF_HYPERLINKS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_USE_PDFLATEX)
    SET(DOXYGEN_USE_PDFLATEX YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_LATEX_BATCHMODE)
    SET(DOXYGEN_LATEX_BATCHMODE NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_LATEX_HIDE_INDICES)
    SET(DOXYGEN_LATEX_HIDE_INDICES NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_LATEX_SOURCE_CODE)
    SET(DOXYGEN_LATEX_SOURCE_CODE NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_LATEX_BIB_STYLE)
    SET(DOXYGEN_LATEX_BIB_STYLE plain)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_LATEX_TIMESTAMP)
    SET(DOXYGEN_LATEX_TIMESTAMP NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_RTF)
    SET(DOXYGEN_GENERATE_RTF NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_RTF_OUTPUT)
    SET(DOXYGEN_RTF_OUTPUT doxygen-rtf)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_COMPACT_RTF)
    SET(DOXYGEN_COMPACT_RTF NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_RTF_HYPERLINKS)
    SET(DOXYGEN_RTF_HYPERLINKS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_RTF_SOURCE_CODE)
    SET(DOXYGEN_RTF_SOURCE_CODE NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_MAN)
    SET(DOXYGEN_GENERATE_MAN NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MAN_OUTPUT)
    SET(DOXYGEN_MAN_OUTPUT doxygen-man)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MAN_EXTENSION)
    SET(DOXYGEN_MAN_EXTENSION .3)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MAN_LINKS)
    SET(DOXYGEN_MAN_LINKS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_XML)
    SET(DOXYGEN_GENERATE_XML NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_XML_OUTPUT)
    SET(DOXYGEN_XML_OUTPUT doxygen-xml)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_XML_PROGRAMLISTING)
    SET(DOXYGEN_XML_PROGRAMLISTING YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_XML_NS_MEMB_FILE_SCOPE)
    SET(DOXYGEN_XML_NS_MEMB_FILE_SCOPE NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_DOCBOOK)
    SET(DOXYGEN_GENERATE_DOCBOOK NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOCBOOK_OUTPUT)
    SET(DOXYGEN_DOCBOOK_OUTPUT doxygen-docbook)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOCBOOK_PROGRAMLISTING)
    SET(DOXYGEN_DOCBOOK_PROGRAMLISTING NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_AUTOGEN_DEF)
    SET(DOXYGEN_GENERATE_AUTOGEN_DEF NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_PERLMOD)
    SET(DOXYGEN_GENERATE_PERLMOD NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_PERLMOD_LATEX)
    SET(DOXYGEN_PERLMOD_LATEX NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_PERLMOD_PRETTY)
    SET(DOXYGEN_PERLMOD_PRETTY YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_ENABLE_PREPROCESSING)
    SET(DOXYGEN_ENABLE_PREPROCESSING YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MACRO_EXPANSION)
    SET(DOXYGEN_MACRO_EXPANSION YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXPAND_ONLY_PREDEF)
    SET(DOXYGEN_EXPAND_ONLY_PREDEF YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SEARCH_INCLUDES)
    SET(DOXYGEN_SEARCH_INCLUDES YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_PREDEFINED)
    SET(DOXYGEN_PREDEFINED IS_DOXYGEN)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_SKIP_FUNCTION_MACROS)
    SET(DOXYGEN_SKIP_FUNCTION_MACROS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_ALLEXTERNALS)
    SET(DOXYGEN_ALLEXTERNALS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTERNAL_GROUPS)
    SET(DOXYGEN_EXTERNAL_GROUPS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_EXTERNAL_PAGES)
    SET(DOXYGEN_EXTERNAL_PAGES YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_PERL_PATH)
    SET(DOXYGEN_PERL_PATH "${PERL}")
  ENDIF()
  IF(NOT DEFINED DOXYGEN_CLASS_DIAGRAMS)
    SET(DOXYGEN_CLASS_DIAGRAMS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HIDE_UNDOC_RELATIONS)
    SET(DOXYGEN_HIDE_UNDOC_RELATIONS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_HAVE_DOT)
    SET(DOXYGEN_HAVE_DOT NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOT_NUM_THREADS)
    SET(DOXYGEN_DOT_NUM_THREADS 0)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOT_FONTNAME)
    SET(DOXYGEN_DOT_FONTNAME Helvetica)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOT_FONTSIZE)
    SET(DOXYGEN_DOT_FONTSIZE 10)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_CLASS_GRAPH)
    SET(DOXYGEN_CLASS_GRAPH YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_COLLABORATION_GRAPH)
    SET(DOXYGEN_COLLABORATION_GRAPH YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GROUP_GRAPHS)
    SET(DOXYGEN_GROUP_GRAPHS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_UML_LOOK)
    SET(DOXYGEN_UML_LOOK NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_UML_LIMIT_NUM_FIELDS)
    SET(DOXYGEN_UML_LIMIT_NUM_FIELDS 10)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_TEMPLATE_RELATIONS)
    SET(DOXYGEN_TEMPLATE_RELATIONS NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INCLUDE_GRAPH)
    SET(DOXYGEN_INCLUDE_GRAPH YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INCLUDED_BY_GRAPH)
    SET(DOXYGEN_INCLUDED_BY_GRAPH YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_CALL_GRAPH)
    SET(DOXYGEN_CALL_GRAPH NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_CALLER_GRAPH)
    SET(DOXYGEN_CALLER_GRAPH NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GRAPHICAL_HIERARCHY)
    SET(DOXYGEN_GRAPHICAL_HIERARCHY YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DIRECTORY_GRAPH)
    SET(DOXYGEN_DIRECTORY_GRAPH YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOT_IMAGE_FORMAT)
    SET(DOXYGEN_DOT_IMAGE_FORMAT svg)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_INTERACTIVE_SVG)
    SET(DOXYGEN_INTERACTIVE_SVG NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOT_GRAPH_MAX_NODES)
    SET(DOXYGEN_DOT_GRAPH_MAX_NODES 50)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_MAX_DOT_GRAPH_DEPTH)
    SET(DOXYGEN_MAX_DOT_GRAPH_DEPTH 1000)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOT_TRANSPARENT)
    SET(DOXYGEN_DOT_TRANSPARENT NO)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOT_MULTI_TARGETS)
    SET(DOXYGEN_DOT_MULTI_TARGETS YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_GENERATE_LEGEND)
    SET(DOXYGEN_GENERATE_LEGEND YES)
  ENDIF()
  IF(NOT DEFINED DOXYGEN_DOT_CLEANUP)
    SET(DOXYGEN_DOT_CLEANUP YES)
  ENDIF()
ENDMACRO(_SETUP_DOXYGEN_DEFAULT_OPTIONS)

# _SETUP_PROJECT_DOCUMENTATION
# ----------------------------
#
# Look for Doxygen, add a custom rule to generate the documentation
# and install the documentation properly.
#
# Available user options (to be set before calling SETUP_PROJECT):
#   DOXYGEN_DOT_IMAGE_FORMAT: format for dot images. Defaults to "svg".
#   DOXYGEN_USE_MATHJAX: use MathJax to render LaTeX equations. Defaults to "NO".
MACRO(_SETUP_PROJECT_DOCUMENTATION)

  # Search for Doxygen.
  FIND_PACKAGE(Doxygen)

  IF(NOT DOXYGEN_FOUND)
    MESSAGE(WARNING "Failed to find Doxygen, documentation will not be generated.")
  ELSE(NOT DOXYGEN_FOUND)
    _SETUP_DOXYGEN_DEFAULT_OPTIONS()
    # Generate variable to be substitued in Doxyfile.in
    # for dot use.
    IF(DOXYGEN_DOT_FOUND)
      SET(DOXYGEN_HAVE_DOT YES)
    ENDIF(DOXYGEN_DOT_FOUND)

    # Teach CMake how to generate the documentation.
    IF(MSVC)
      # FIXME: it is impossible to trigger documentation installation
      # at install, so put the target in ALL instead.
      ADD_CUSTOM_TARGET(doc ALL
        COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
        WORKING_DIRECTORY doc
        COMMENT "Generating Doxygen documentation"
        )
    ELSE(MSVC)
      ADD_CUSTOM_TARGET(doc
        COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
        WORKING_DIRECTORY doc
        COMMENT "Generating Doxygen documentation"
        )

      IF(INSTALL_DOCUMENTATION)
        INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_MAKE_PROGRAM} doc)")
      ENDIF(INSTALL_DOCUMENTATION)
    ENDIF(MSVC)

    IF (DOXYGEN_USE_TEMPLATE_CSS)
      ADD_CUSTOM_COMMAND(
        OUTPUT
        ${CMAKE_CURRENT_BINARY_DIR}/doc/header.html
        ${CMAKE_CURRENT_BINARY_DIR}/doc/footer.html
        ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen.css
        COMMAND ${DOXYGEN_EXECUTABLE} -w html
        ${CMAKE_CURRENT_BINARY_DIR}/doc/header.html
        ${CMAKE_CURRENT_BINARY_DIR}/doc/footer.html
        ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen.css
        WORKING_DIRECTORY doc
        COMMENT "Generating Doxygen template files"
        )
      ADD_CUSTOM_TARGET(generate-template-css
        DEPENDS
        ${CMAKE_CURRENT_BINARY_DIR}/doc/header.html
        ${CMAKE_CURRENT_BINARY_DIR}/doc/footer.html
        ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen.css
        )
      ADD_DEPENDENCIES(doc generate-template-css)
    ELSE (DOXYGEN_USE_TEMPLATE_CSS)
      FILE (COPY
        ${PROJECT_SOURCE_DIR}/cmake/doxygen/doxygen.css
        DESTINATION
        ${CMAKE_CURRENT_BINARY_DIR}/doc/
        )
    ENDIF (DOXYGEN_USE_TEMPLATE_CSS)

    ADD_CUSTOM_COMMAND(
      OUTPUT
      ${CMAKE_CURRENT_BINARY_DIR}/doc/${PROJECT_NAME}.doxytag
      ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen-html
      COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
      WORKING_DIRECTORY doc
      COMMENT "Generating Doxygen documentation"
      )

    # Clean generated files.
    SET_PROPERTY(
      DIRECTORY APPEND PROPERTY
      ADDITIONAL_MAKE_CLEAN_FILES
      ${CMAKE_CURRENT_BINARY_DIR}/doc/${PROJECT_NAME}.doxytag
      ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen.log
      ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen-html
      )

    # Install MathJax minimal version.
    IF(${DOXYGEN_USE_MATHJAX} STREQUAL "YES")
      FILE(COPY ${PROJECT_SOURCE_DIR}/cmake/doxygen/MathJax
           DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen-html)
    ENDIF()

    # Install generated files.
    IF(INSTALL_DOCUMENTATION)
      INSTALL(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/doc/${PROJECT_NAME}.doxytag
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/doxygen-html)
      INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen-html
        DESTINATION ${CMAKE_INSTALL_DOCDIR})

      IF(EXISTS ${PROJECT_SOURCE_DIR}/doc/pictures)
        INSTALL(DIRECTORY ${PROJECT_SOURCE_DIR}/doc/pictures
          DESTINATION ${CMAKE_INSTALL_DOCDIR}/doxygen-html)
      ENDIF(EXISTS ${PROJECT_SOURCE_DIR}/doc/pictures)
    ENDIF(INSTALL_DOCUMENTATION)

    LIST(APPEND LOGGING_WATCHED_VARIABLES
      DOXYGEN_SKIP_DOT
      DOXYGEN_EXECUTABLE
      DOXYGEN_FOUND
      DOXYGEN_DOT_EXECUTABLE
      DOXYGEN_DOT_FOUND
      DOXYGEN_DOT_PATH
      DOXYGEN_DOT_IMAGE_FORMAT
      DOXYGEN_USE_MATHJAX
      DOXYGEN_USE_TEMPLATE_CSS
      )
  ENDIF(NOT DOXYGEN_FOUND)
ENDMACRO(_SETUP_PROJECT_DOCUMENTATION)

# _DOXYTAG_ENTRIES_FROM_CMAKE_DEPENDENCIES
# ----------------------------------------
#
# Generate TAGFILES entries from this project dependencies and their
# dependencies (recursively)
#
MACRO(_DOXYTAG_ENTRIES_FROM_CMAKE_DEPENDENCIES DEPENDENCIES VAR_OUT)
  FOREACH(PREFIX ${DEPENDENCIES})
    IF( DEFINED ${PREFIX}_DOXYGENDOCDIR
        AND EXISTS ${${PREFIX}_DOXYGENDOCDIR}/${PREFIX}.doxytag)
      SET(${VAR_OUT} "${${VAR_OUT}} \"${${PREFIX}_DOXYGENDOCDIR}/${PREFIX}.doxytag\"=\"${${PREFIX}_DOXYGENDOCDIR}\"")
    ENDIF()
    IF( DEFINED ${PREFIX}_DEPENDENCIES )
      _DOXYTAG_ENTRIES_FROM_CMAKE_DEPENDENCIES("${${PREFIX}_DEPENDENCIES}" ${VAR_OUT})
    ENDIF()
  ENDFOREACH()
ENDMACRO()

# _SETUP_PROJECT_DOCUMENTATION_FINALIZE
# -------------------------------------
#
# Post-processing for the documentation generation macro.
#
# Doxyfile.extra and Doxyfile files are generated at the end to allow
# the replacement of user-defined variables.
#
MACRO(_SETUP_PROJECT_DOCUMENTATION_FINALIZE)
  IF(DOXYGEN_FOUND)
    IF(NOT ${DOXYGEN_USE_MATHJAX} STREQUAL "YES")
      # Make sure latex, dvips and gs are available
      FIND_PROGRAM(LATEX latex DOC "LaTeX compiler")
      FIND_PROGRAM(DVIPS dvips DOC "DVI to PostScript converter")
      FIND_PROGRAM(GS gs DOC "GhostScript interpreter")

      IF(NOT (LATEX AND GS AND DVIPS))
        MESSAGE(STATUS "Failed to find latex/dvips/gs, will use MathJax backend.")
        SET(DOXYGEN_USE_MATHJAX "YES")
      ENDIF()
    ENDIF()

    IF(${DOXYGEN_USE_MATHJAX} STREQUAL "YES")
      MESSAGE(STATUS "Doxygen rendering: using MathJax backend")
      SET(DOXYGEN_HEADER_NAME "header-mathjax.html")
    ELSE()
      MESSAGE(STATUS "Doxygen rendering: using LaTeX backend")
      SET(DOXYGEN_HEADER_NAME "header.html")
    ENDIF()

    IF(INSTALL_DOCUMENTATION)
      # Find doxytag files
      # To ignore this list of tag files, add to doc/Doxyfile.extra.in
      # TAGFILES =
      SET(PKG_REQUIRES ${_PKG_CONFIG_REQUIRES})
      _ADD_TO_LIST(PKG_REQUIRES "${_PKG_CONFIG_COMPILE_TIME_REQUIRES}" ",")
      STRING(REPLACE "," ";" PKG_REQUIRES "${PKG_REQUIRES}")
      FOREACH(PKG_CONFIG_STRING ${PKG_REQUIRES})
        _PARSE_PKG_CONFIG_STRING(${PKG_CONFIG_STRING} LIBRARY_NAME PREFIX PKG_CONFIG_STRING_NOSPACE)
        # If DOXYGENDOCDIR is specified, add a doc path.
        IF( DEFINED ${PREFIX}_DOXYGENDOCDIR
            AND EXISTS ${${PREFIX}_DOXYGENDOCDIR}/${LIBRARY_NAME}.doxytag)
          FILE(RELATIVE_PATH DEP_DOCDIR ${_PKG_CONFIG_DOXYGENDOCDIR} ${${PREFIX}_DOXYGENDOCDIR})

          SET(DOXYTAG_ENTRIES "${DOXYTAG_ENTRIES} \"${${PREFIX}_DOXYGENDOCDIR}/${LIBRARY_NAME}.doxytag\"=\"${DEP_DOCDIR}\"")
        ENDIF()
      ENDFOREACH()
      _DOXYTAG_ENTRIES_FROM_CMAKE_DEPENDENCIES("${_PACKAGE_CONFIG_DEPENDENCIES_PROJECTS}" DOXYTAG_ENTRIES)
    ENDIF()

    IF(EXISTS ${PROJECT_SOURCE_DIR}/include)
      SET (DOXYGEN_INCLUDE_PATH "${DOXYGEN_INCLUDE_PATH} \"${PROJECT_SOURCE_DIR}/include\"")
      SET (DOXYGEN_INPUT "${DOXYGEN_INPUT} \"${PROJECT_SOURCE_DIR}/include\"")
    ENDIF()
    IF(EXISTS ${PROJECT_SOURCE_DIR}/src)
      SET (DOXYGEN_INPUT "${DOXYGEN_INPUT} \"${PROJECT_SOURCE_DIR}/src\"")
    ENDIF()
    IF(EXISTS ${PROJECT_SOURCE_DIR}/tests)
      SET (DOXYGEN_EXAMPLE_PATH "${DOXYGEN_EXAMPLE_PATH} \"${PROJECT_SOURCE_DIR}/tests\"")
    ENDIF()
    SET (DOXYGEN_INCLUDE_PATH "${DOXYGEN_INCLUDE_PATH} \"${CMAKE_BINARY_DIR}/include\"")

    # Generate Doxyfile.extra.
    IF(EXISTS ${PROJECT_SOURCE_DIR}/doc/Doxyfile.extra.in)
      CONFIGURE_FILE(
        ${PROJECT_SOURCE_DIR}/doc/Doxyfile.extra.in
        ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile.extra
        @ONLY
        )
    ELSE()
      CONFIGURE_FILE(
        ${PROJECT_SOURCE_DIR}/cmake/doxygen/Doxyfile.extra.in
        ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile.extra
        @ONLY
        )
    ENDIF()
    # Generate Doxyfile.
    CONFIGURE_FILE(
      ${PROJECT_SOURCE_DIR}/cmake/doxygen/Doxyfile.in
      ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile
      @ONLY
      )
    FILE(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile.extra doxyfile_extra)
    FOREACH(x ${doxyfile_extra})
      FILE(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile ${x} "\n")
    ENDFOREACH(x in doxyfile_extra)
  ENDIF(DOXYGEN_FOUND)
ENDMACRO(_SETUP_PROJECT_DOCUMENTATION_FINALIZE)
